<template>
  <div class="flex flex-nowrap flex-row items-center w-full">
    <input
      class="bg-white dark:bg-gray-800 rounded-tl-2xl rounded-bl-2xl h-12 border-2 border-r-0 border-blue-700 dark:border-indigo-300 px-2 pl-3 pr-2 focus:border-blue-900 dark:focus:border-indigo-500 focus:outline-none w-full"
      :aria-label="placeholder"
      :placeholder="placeholder"
      :value="value"
      v-bind="$attrs"
      @focus="setFocused"
      @blur="setUnfocused"
      @input="$emit('update:value', $event.target.value)"
    />
    <search-button
      :class="[inputFocused ? 'border-blue-900  dark:border-indigo-500' : 'border-blue-700 dark:border-indigo-300']"
    />
  </div>
</template>

<script lang="ts">
import { defineComponent } from 'vue';

// Components
import SearchButton from '@/components/Button/SearchButton.vue';

export default defineComponent({
  name: 'SearchBar',
  components: {
    SearchButton
  },
  inheritAttrs: false,
  data() {
    return {
      inputFocused: false
    };
  },
  props: {
    placeholder: {
      type: String
    },
    value: {
      type: String,
      required: true
    }
  },
  emits: ['update:value'],
  methods: {
    setFocused() {
      this.inputFocused = true;
    },
    setUnfocused() {
      this.inputFocused = false;
    }
  }
});
</script>
